
{$APPTYPE GUI}{$MODE DELPHI}

program demo52;

uses
  SysUtils,windows,math,gl,glu,GraphOGL,GOGL_SmoothGFX;

//const
 
//type
  
//var 

   
//{$R *.rc}
//{$R *.res}  
 
// Questo tipo di rendering ad alte prestazioni, puo risultare lento o a scatti se non si dispone
// di una bouna accelerazione video. 

// SP_2,SP_3,SP_4,SP_8,SP_15 - Queste sono le variabili per la selezione della qualit del rendering, 
// che definiscno il numero di punti relativi alla sfumatura, usata per unifomare i margini dei poligoni 
 
procedure Quad(x1,y1,z1,x2,y2,z2,x3,y3,z3,x4,y4,z4:glFloat);
begin
  TwoSideON;
  glDisable(GL_CULL_FACE);
  glBegin(GL_QUADS);
   FindNormal(x2,y2,z2,x1,y1,z1,x3,y3,z3);
   glNormal3f(FNormal[1], FNormal[2], FNormal[3]);
	LineFree(3,3, 0,3, x2,y2,z2, x1,y1,z1,true);
	LineFree(0,0, 3,0, x3,y3,z3, x4,y4,z4,true);	
  glEnd;
  glEnable(GL_CULL_FACE);
  TwoSideOFF;  
end; 


procedure OpenGL_CreateList();

procedure OpenGL_Texture();
begin    
  
  TextureLoadID('Floor04.bmp',0);
  TextureLoadID('rock.bmp',1);
  TextureLoadID('stoneblocks.bmp',2);  
  TextureLoadID('marmorizato.bmp',3);
  
end;
begin 

  OpenGL_Texture();

  GFX_Init(0,0,0,0);        
  
end;


procedure OpenGL_Draw();

{procedure OpenGL_Draw2D();
begin
 
end;}
procedure OpenGL_Mouse2D();
begin
  
end;
procedure OpenGL_Keyboard();
begin
  
end;
begin

  glClear(GL_COLOR_BUFFER_BIT OR GL_DEPTH_BUFFER_BIT);
  glLoadIdentity();
 
  //OpenGL_Draw2D();               // carica gli elementi per la grafica 2d 
  OpenGL_Mouse2D();              // carica i comandi del mause per la grafica 2d
  OpenGL_Keyboard();             // carica i comandi della tastiera
  
  glTranslatef(0,0,-30-depth);        // regola l'inquadratura degli elementi nello schermo
  glRotatef(50,1,0,0); 
  
  SetglMouseMove(GL_M0,2);
  glTranslatef(0,0,depth);  
  glRotatef(45,0,1,0);   
  
  PutglPointLight(GL_LIGHT0,0, 0,10,0, 0.1); 

  // terreno
  TextureSelectID(0);  
  Quad(-10,0,-10, 10,0,-10, -10,0,10, 10,0,10);  
  
  TextureSelectID(1);    
  Cubo2(0,0,0, -3,0,-3, 3,0.5,3, 0.5);
  Cubo2(0,0.5,0, -2.5,0,-2.5, 2.5,0.5,2.5, 0.5); 
  Cubo2(0,0.5*2,0, -2,0,-2, 2,0.5,2, 0.5); 
  Cubo2(0,0.5*3,0, -1.5,0,-1.5, 1.5,0.5,1.5, 0.5); 
  Cubo2(0,0.5*4,0, -1,0,-1, 1,0.5,1, 0.5);
  Cubo2(0,0.5*5,0, -0.5,0,-0.5, 0.5,0.5,0.5, 0.5);   
     
  Cubo2(-6,0,-2, -0.25,0,-0.25, 0.25,3,0.25, 0.5);	 
  Cubo2(-6,0,0, -0.25,0,-0.25, 0.25,3,0.25, 0.5);
  Cubo2(-6,0,2, -0.25,0,-0.25, 0.25,3,0.25, 0.5);  
 
  Cubo2(0,0,-5, -6.5,0,-0.25, 3,1.6,0.25, 0.5);
  
  // torre
  TextureSelectID(2);   
  Cubo2(6,0,0, -0.7,0,-0.7, 0.7,4.5,0.7, 0.5);   
  Cubo2(6,4.5,0, -1,0,-1, 1,0.5,1, 0.5);
  Cubo2(6-0.9,5,-0.9, -0.1,0,-0.1, 0.1,0.25,0.1, 0.5);  
  Cubo2(6-0.9,5,-0.9+0.6, -0.1,0,-0.1, 0.1,0.25,0.1, 0.5);  
  Cubo2(6-0.9,5,-0.9+0.6*2, -0.1,0,-0.1, 0.1,0.25,0.1, 0.5);    
  Cubo2(6-0.9,5,-0.9+0.6*3, -0.1,0,-0.1, 0.1,0.25,0.1, 0.5);
  Cubo2(6+0.9,5,-0.9, -0.1,0,-0.1, 0.1,0.25,0.1, 0.5);  
  Cubo2(6+0.9,5,-0.9+0.6, -0.1,0,-0.1, 0.1,0.25,0.1, 0.5);  
  Cubo2(6+0.9,5,-0.9+0.6*2, -0.1,0,-0.1, 0.1,0.25,0.1, 0.5);    
  Cubo2(6+0.9,5,-0.9+0.6*3, -0.1,0,-0.1, 0.1,0.25,0.1, 0.5);  
  Cubo2(6-0.9+0.6,5,-0.9, -0.1,0,-0.1, 0.1,0.25,0.1, 0.5);  
  Cubo2(6-0.9+0.6*2,5,-0.9, -0.1,0,-0.1, 0.1,0.25,0.1, 0.5);   
  Cubo2(6-0.9+0.6,5,0.9, -0.1,0,-0.1, 0.1,0.25,0.1, 0.5);  
  Cubo2(6-0.9+0.6*2,5,0.9, -0.1,0,-0.1, 0.1,0.25,0.1, 0.5); 
 
  // scultura
  TextureSelectID(3);  
  glPushMatrix;
  glTranslatef(0,0,7.5);   
  glRotatef(90,-1,0,0); 
  PutglTeapot(0,0,0, 1,32);
  glPopMatrix;   
  
end;

// inizio del programma
begin

 if MessageBox(0,'Settare lo schermo intero?  ', 'Video!',MB_YESNO OR MB_ICONQUESTION) = IDNO 
  then fullscreen := false else fullscreen := true;
  
 OGLWindowSetting(ARROW,'',GENERIC,'');
 CreateOGLWindow('Smooth GFX rendering', 800, 600, 32, fullscreen);// si possono usare anche dei rapporti diversi da 4/3 o 16/9
 //OpenGL_Init(100,0,0,0,0);			  // inizializza la grafica OpenGL(consente d'impostare il colore di sfondo e la profondit della visuale) 
 SetglRefractive();                         // imposta la rifrazione ambientale ed elimina le facce interne
 SetglLight(GL_LIGHT0,0.0,0.0,0.0,0.1);     // imposta la luce ambientale
 OpenGL_CreateList();                       // carica le liste degli oggetti (modelli composti)

 // impostare qui i valori delle variabili   

 REPEAT				     // inizio del ciclo principale

 glCLEAR(GL_COLOR_BUFFER_BIT);
 Setglmsg();

 //OpenGL_Draw();             // carica gli elementi che devono essere aggiornati sullo schermo 
 OpenGL_GFX_Init(OpenGL_Draw,SP_4,100); // carica gli elementi e applica il rendering con smooth gfx
 SwapBuffers(dcWindow);	    // abilita la visualizzazione grafica OpenGL

 // inserire qui eventuali dati aggiuntivi

UNTIL active = false;		// fine del ciclo principale (premere ESC per uscire)

 DeleteOGLWindow();		    // chiude la finestra
end.
